#!/usr/bin/env perl

####################################################################
# CVS Activity Notifying Tool
# $Id: cvsnotify-indent.pl,v 1.2 2004/05/29 04:36:19 pynoos Exp $
# Copyright (C) 2004 by Hojin Choi <pynoos@users.kldp.net>
# You can redistribute this software under GPL.
####################################################################

sub indent_preprocess(@)
{
	my $indent = $conf{'indent'};
	unless( $indent )
	{
		print "Error: indent is not specified.\n";
		return 0;
	}
	unless( -x $indent )
	{
		log_debug( "Error: indent [$indent] is not runnable.\n");
		return 0;
	}
	log_debug( "Indentation: files [". (length($@) + 1) . "]\n");
	return 1;
}

sub insert_id($)
{
	my( $file ) = shift;
	open FILE, $file or return;
	unless( grep {/\$Id:/} <FILE>  )
	{
		close( FILE );
		open FILE, ">>$file" or return;
		print FILE "\n/* \$" . "Id: \$ */\n";
	}
	close( FILE );
}

sub indent_foreach($)
{
	my $file = shift;
	unless( -f $file )
	{
		log_debug( "There is no such a file.\n");
		return;
	}

	my $indent = $conf{'indent'};

	log_debug( "Indentation: file [$file]\n");
	unless( /.*\.(.*)$/ )
	{
		log_debug( "Indentation: skip $file\n");
		return;
	}

	my $ext = $1;
	if( index($conf{'indent_ext'},$ext) > 0 )
	{
		my $indent_home = $conf{'indent_home'};
		unless( $indent_home )
		{
			$indent_home = "$cvsroot/CVSROOT";
		}

		insert_id($file);
		print "Fix indentation: $file\n";
		log_debug( "Indentation: $file\n");
		log_debug( "Indentation: command line: LC_ALL=C HOME=\"$indent_home\" $indent \"$file\"\n");
		system( "LC_ALL=C HOME=\"$indent_home\" $indent \"$file\"" ) 
	}
	return;
}

sub indent_postprocess(@)
{
	return 1;
}

# End of script.
1
