#!/usr/bin/env perl
#####################################################
# CVSROOT Management Tool
# Author     : Hojin Choi <pynoos@users.kldp.net>
# Last update: 2004/2/12
# $Revision: 1.1 $
#####################################################

sub lock_preprocess(@)
{
	my $lock_rule = get_matched_pattern( $module, "lock_module", "cvsnotify-lock" );
	if( $lock_rule )
	{
		log_user( "Directory '$module' is locked. by rule [$lock_rule]\n");
		$lock_rule = get_matched_pattern( $module, "lock_except_user", "cvsnotify-lock" );
		if( $lock_rule )
		{
			log_debug( "$file is locked, but user is exception by $lock_rule\n" );
			return;
		}
		exit 1;
	}
	log_debug( "There is none of module lock condition\n");
	return 1;
}

sub lock_foreach($)
{
	my $file = shift;
	unless( -f $file )
	{
		log_debug("There is no such a file.\n");
		return;
	}

	log_debug("File lock check: file [$file]\n");

	my $lock_rule = get_matched_pattern( $file, "lock_file", "cvsnotify-lock" );
	if( $lock_rule )
	{
		log_user( "File '$file' is locked. by rule [$lock_rule]\n");
		$lock_rule = get_matched_pattern( $file, "lock_except_user", "cvsnotify-lock" );
		if( $lock_rule )
		{
			log_debug( "$file is locked, but user is exception by $lock_rule\n" );
			return;
		}
		exit 1;
	}
	log_debug( "There is none of file lock condition\n" );
	return;
}

sub lock_postprocess(@)
{
	return 1;
}

# End of script.
1
